%% please download FastICA_25 http://www.cis.hut.fi/projects/ica/fastica/
% About FastICA
% The FastICA package for MATLAB was programmed by the following people working at the Laboratory of Information and Computer Science in the Helsinki University of Technology:
% 
% Hugo G?vert (Graphical User Interface and main coding)
% Jarmo Hurri (Original main coding in 1996-1997)
% Jaakko S?rel?
% Aapo Hyv?rinen

load('Bird_Raw_LFP_3.mat') 
%% B5 (towel restraint)
ICAB5=[];A5=[];
for ii = 1: size(LFPB5,2)
    X2=[LFPB5(:,ii) LFPB5_1(:,ii) LFPB5_2(:,ii) LFPB5_3(:,ii) ];
   [icasig, A, W] = fastica(X2','numOfIC',1,'displayMode','off','firstEig',1,'lastEig',1);  
  A5=[A5 A(1)];
   ICAB5=[ICAB5;icasig];
end
   ICAB5=ICAB5';
   newICAB5=(A5.*ICAB5); %transform the estimated independent components to LFP unit (millivolt)
  % save ICA_Bird5 t A5 ICAB5 newICAB5
figure
x0=100;
y0=50;
width=550;
height=900;
set(gcf,'position',[x0,y0,width,height])
for ii=1: size(newICAB5,2)
    subplot(10,2,ii)
    
     plot(t,newICAB5(:,ii));ylim([-0.13 0.13])
end



Zscore_LFPB5=zscore(newICAB5,0,1);
param = struct('tapers',[3 5], 'Fs',2000, 'pad', 2,'fpass',[3 100],'trialave',0);
% for the mtspecgramc, please download the toolbox http://chronux.org/
for i=1:size(Zscore_LFPB5,2)
[B5S,t2,f]=mtspecgramc(Zscore_LFPB5(:,i),[0.5 0.05],param);B5zscore (:,:,i)= (B5S - nanmean(B5S))./nanstd(B5S);
end

B5spectrogram= boxcarSmoothing(nanmean(B5zscore,3)); 
figure;imagesc(t2, f,B5spectrogram');axis xy; colormap jet;ccc=colorbar;
title('B5 ICA')
ylim([3.4 50])
 caxis([-0.5 1.4])


%% B6 (towel restraint)

ICAB6=[];A6=[];
for ii = 1: size(LFPB6,2)
    X2=[LFPB6(:,ii) LFPB6_1(:,ii) LFPB6_2(:,ii) ];
   [icasig, A, W] = fastica(X2','numOfIC',1,'displayMode','off','firstEig',1,'lastEig',1);  
   A6=[A6 A(1)];
   ICAB6=[ICAB6;icasig];
end
   ICAB6=ICAB6';
   newICAB6=(A6.*ICAB6); %transform the estimated independent components to LFP unit (millivolt)
  % save ICA_Bird6 t A6 ICAB6 newICAB6
figure
x0=100;
y0=50;
width=550;
height=900;
set(gcf,'position',[x0,y0,width,height])
for ii=1: size(ICAB6,2)
    subplot(10,2,ii)
     
     plot(t,newICAB6(:,ii));ylim([-0.3 0.3])
end



Zscore_LFPB6=zscore(newICAB6,0,1);
param = struct('tapers',[3 5], 'Fs',2000, 'pad', 2,'fpass',[3 100],'trialave',0);
% for the mtspecgramc, please download the toolbox http://chronux.org/
for i=1:size(Zscore_LFPB6,2)
[B6S,t2,f]=mtspecgramc(Zscore_LFPB6(:,i),[0.5 0.05],param);B6zscore (:,:,i)= (B6S - nanmean(B6S))./nanstd(B6S);
end
B6spectrogram= boxcarSmoothing(nanmean(B6zscore,3)); 
figure;imagesc(t2, f,B6spectrogram');axis xy; colormap jet;ccc=colorbar;
title('B6 ICA')
ylim([3.4 50])
 caxis([-0.5 1.4])
%%
% Gaussian smoothing using a boxcar method
function sMap = boxcarSmoothing(map)

% Load the box template
box = boxcarTemplate2D();

% Using pos and phase naming for the bins originate from the first use of
% this function.
[numPhaseBins,numPosBins] = size(map);

sMap = zeros(numPhaseBins,numPosBins);

for ii = 1:numPhaseBins
    for jj = 1:numPosBins
        for k = 1:5
            % Phase index shift
            sii = k-3;
            % Phase index
            phaseInd = ii+sii;
            % Boundary check
            if phaseInd<1
                phaseInd = 1;
            end
            if phaseInd>numPhaseBins
                phaseInd = numPhaseBins;
            end
            
            for l = 1:5
                % Position index shift
                sjj = l-3;
                % Position index
                posInd = jj+sjj;
                % Boundary check
                if posInd<1
                    posInd = 1;
                end
                if posInd>numPosBins
                    posInd = numPosBins;
                end
                % Add to the smoothed rate for this bin
                sMap(ii,jj) = sMap(ii,jj) + map(phaseInd,posInd) * box(k,l);
            end
        end
    end
end
end

%%
function box = boxcarTemplate2D()

% Gaussian boxcar template
box = [0.0025 0.0125 0.0200 0.0125 0.0025;...
       0.0125 0.0625 0.1000 0.0625 0.0125;...
       0.0200 0.1000 0.1600 0.1000 0.0200;...
       0.0125 0.0625 0.1000 0.0625 0.0125;...
       0.0025 0.0125 0.0200 0.0125 0.0025;];
end