load('Bird_Raw_LFP_3.mat') 
% variable notes:

% t = time
% LFPB1;%LFP from towel-restrained B1
% LFPB2=;%LFP from chemical restrained B2
% LFPB3;%LFP from chemical restrained B3
% LFPB4;%LFP from chemical restrained B4
% LFPB5;%LFP from towel-restrained B5
% LFPB5_1,LFPB5_2,LFPB5_3,;% LFPs from other 3 wires of the same electrode
% we use them to do independent component analysis 
% (see the code: for_peerJ_ICA_code.m)
% LFPB6;%LFP from towel-restrained B6
% LFPB6_1,LFPB6_2,LFPB6_3,;% LFPs from other 3 wires of the same electrode
% we use them to do independent component analysis 
% (we excluded LFP6_3 because it has no LFP signals)
% (see the code: for_peerJ_ICA_code.m)
% LFPB7;%LFP from towel-restrained+diazepam B7
% LFPB8;%LFP from towel-restrained B8. stimuli were blocked by a black EVA foam


%% Z scored LFP
Zscore_LFPB1=zscore(LFPB1,0,1);%towel-restrained
Zscore_LFPB2=zscore(LFPB2,0,1);%chemical restrained
Zscore_LFPB3=zscore(LFPB3,0,1);%chemical restrained
Zscore_LFPB4=zscore(LFPB4,0,1);%chemical restrained
Zscore_LFPB5=zscore(LFPB5,0,1);%towel-restrained
Zscore_LFPB6=zscore(LFPB6,0,1);%towel-restrained
Zscore_LFPB7=zscore(LFPB7,0,1);%towel-restrained+diazepam
Zscore_LFPB8=zscore(LFPB8,0,1);%towel-restrained+stimuli were blocked by a black EVA foam


mean_zscore_LFPB1=mean(Zscore_LFPB1,2);
mean_zscore_LFPB2=mean(Zscore_LFPB2,2);
mean_zscore_LFPB3=mean(Zscore_LFPB3,2);
mean_zscore_LFPB4=mean(Zscore_LFPB4,2);
mean_zscore_LFPB5=mean(Zscore_LFPB5,2);
mean_zscore_LFPB6=mean(Zscore_LFPB6,2);
mean_zscore_LFPB7=mean(Zscore_LFPB7,2);
mean_zscore_LFPB8=mean(Zscore_LFPB8,2);
sem_LFPB1=std(Zscore_LFPB1,0,2)./sqrt(size(Zscore_LFPB1,2)-1);
sem_LFPB2=std(Zscore_LFPB2,0,2)./sqrt(size(Zscore_LFPB2,2)-1);
sem_LFPB3=std(Zscore_LFPB3,0,2)./sqrt(size(Zscore_LFPB3,2)-1);
sem_LFPB4=std(Zscore_LFPB4,0,2)./sqrt(size(Zscore_LFPB4,2)-1);
sem_LFPB5=std(Zscore_LFPB5,0,2)./sqrt(size(Zscore_LFPB5,2)-1);
sem_LFPB6=std(Zscore_LFPB6,0,2)./sqrt(size(Zscore_LFPB6,2)-1);
sem_LFPB7=std(Zscore_LFPB7,0,2)./sqrt(size(Zscore_LFPB7,2)-1);
sem_LFPB6=std(Zscore_LFPB8,0,2)./sqrt(size(Zscore_LFPB8,2)-1);

% a figure example, replace the numbers to plot a different bird
figure
plot(t,mean_zscore_LFPB6); xlim([-1 1]);hold on
plot (t,mean_zscore_LFPB6-sem_LFPB6,t,mean_zscore_LFPB6+sem_LFPB6); hold off;ylim([-1.5 3])

%% Spectrum
params = struct('tapers',[3,5], 'Fs',2000, 'pad', 2,'fpass',[1 120],'err',[2 0.05],'trialave',1);
% for the mtspectrumc, please download the toolbox http://chronux.org/
[SpreB1,f,SerrpreB1]=mtspectrumc(LFPB1(1:2000,:),params); %-1~0 sec %towel-restrained
[SproB1,f,SerrproB1]=mtspectrumc(LFPB1(2001:4000,:),params); %0~1 sec
[SpreB2,f,SerrpreB2]=mtspectrumc(LFPB2(1:2000,:),params); %-1~0 sec %chemical restrained
[SproB2,f,SerrproB2]=mtspectrumc(LFPB2(2001:4000,:),params); %0~1 sec 
[SpreB3,f,SerrpreB3]=mtspectrumc(LFPB3(1:2000,:),params); %-1~0 sec %chemical restrained
[SproB3,f,SerrproB3]=mtspectrumc(LFPB3(2001:4000,:),params); %0~1 sec
[SpreB4,f,SerrpreB4]=mtspectrumc(LFPB4(1:2000,:),params); %-1~0 sec %chemical restrained
[SproB4,f,SerrproB4]=mtspectrumc(LFPB4(2001:4000,:),params); %0~1 sec 
[SpreB5,f,SerrpreB5]=mtspectrumc(LFPB5(1:2000,:),params); %-1~0 sec %towel-restrained
[SproB5,f,SerrproB5]=mtspectrumc(LFPB5(2001:4000,:),params); %0~1 sec
[SpreB6,f,SerrpreB6]=mtspectrumc(LFPB6(1:2000,:),params); %-1~0 sec %towel-restrained
[SproB6,f,SerrproB6]=mtspectrumc(LFPB6(2001:4000,:),params); %0~1 sec
[SpreB7,f,SerrpreB7]=mtspectrumc(LFPB7(1:2000,:),params); %-1~0 sec %towel-restrained + diazepam
[SproB7,f,SerrproB7]=mtspectrumc(LFPB7(2001:4000,:),params); %0~1 sec
[SpreB8,f,SerrpreB8]=mtspectrumc(LFPB8(1:2000,:),params); %-1~0 sec %towel-restrained +stimuli were blocked by a black EVA foam
[SproB8,f,SerrproB8]=mtspectrumc(LFPB8(2001:4000,:),params); %0~1 sec

% a figure example, replace the numbers to plot a different bird
figure 
plot(f,10*log(SpreB1));xlabel('Hz');ylabel('dB');title('Bird 1 -1sec'); hold on
plot(f,10*log(SerrpreB1(1,:)),f,10*log(SerrpreB1(2,:))); hold off

figure 
plot(f,10*log(SproB1));xlabel('Hz');ylabel('dB');title('Bird 1 +1sec'); hold on
plot(f,10*log(SerrproB1(1,:)),f,10*log(SerrproB1(2,:))); hold off
%% Spectrogram

param = struct('tapers',[3 5], 'Fs',2000, 'pad', 2,'fpass',[3 100]);
% for the mtspecgramc, please download the toolbox http://chronux.org/
for i=1:size(LFPB1,2)
[B1S,t3,f]=mtspecgramc(LFPB1(:,i),[0.5 0.05],param);B1Szscore (:,:,i)= (B1S - nanmean(B1S))./nanstd(B1S);
end
B1spectrogram= boxcarSmoothing(nanmean(B1Szscore,3)); %towel-restrained

for i=1:size(LFPB2,2)
[B2S,t3,f]=mtspecgramc(LFPB2(:,i),[0.5 0.05],param);B2Szscore (:,:,i)= (B2S - nanmean(B2S))./nanstd(B2S);
end
B2spectrogram= boxcarSmoothing(nanmean(B2Szscore,3)); %chemical restrained

for i=1:size(LFPB3,2)
[B3S,t3,f]=mtspecgramc(LFPB3(:,i),[0.5 0.05],param);B3Szscore (:,:,i)= (B3S - nanmean(B3S))./nanstd(B3S);
end
B3spectrogram= boxcarSmoothing(nanmean(B3Szscore,3)); %chemical restrained

for i=1:size(LFPB4,2)
[B4S,t3,f]=mtspecgramc(LFPB4(:,i),[0.5 0.05],param);B4Szscore (:,:,i)= (B4S - nanmean(B4S))./nanstd(B4S);
end
B4spectrogram= boxcarSmoothing(nanmean(B4Szscore,3)); %chemical restrained

for i=1:size(LFPB5,2)
[B5S,t3,f]=mtspecgramc(LFPB5(:,i),[0.5 0.05],param);B5Szscore (:,:,i)= (B5S - nanmean(B5S))./nanstd(B5S);
end
B5spectrogram= boxcarSmoothing(nanmean(B5Szscore,3)); %towel-restrained

for i=1:size(LFPB6,2)
[B6S,t3,f]=mtspecgramc(LFPB6(:,i),[0.5 0.05],param);B6Szscore (:,:,i)= (B6S - nanmean(B6S))./nanstd(B6S);
end
B6spectrogram= boxcarSmoothing(nanmean(B6Szscore,3)); %towel-restrained

for i=1:size(LFPB7,2)
[B7S,t3,f]=mtspecgramc(LFPB7(:,i),[0.5 0.05],param);B7Szscore (:,:,i)= (B7S - nanmean(B7S))./nanstd(B7S);
end
B7spectrogram= boxcarSmoothing(nanmean(B7Szscore,3)); %towel-restrained + diazepam

for i=1:size(LFPB8,2)
[B8S,t3,f]=mtspecgramc(LFPB8(:,i),[0.5 0.05],param);B8Szscore (:,:,i)= (B8S - nanmean(B8S))./nanstd(B8S);
end
B8spectrogram= boxcarSmoothing(nanmean(B8Szscore,3)); %towel-restrained+ stimuli were blocked by a black EVA foam


% a figure example, replace the numbers to plot different bird
figure
imagesc(t3, f, boxcarSmoothing(B7spectrogram')); axis xy; colormap jet;ccc=colorbar;title('Bird 7 Spectrogram');ylim([3.4 50])
 caxis([-0.5 1.4])
%%
% Gaussian smoothing using a boxcar method
function sMap = boxcarSmoothing(map)

% Load the box template
box = boxcarTemplate2D();

% Using pos and phase naming for the bins originate from the first use of
% this function.
[numPhaseBins,numPosBins] = size(map);

sMap = zeros(numPhaseBins,numPosBins);

for ii = 1:numPhaseBins
    for jj = 1:numPosBins
        for k = 1:5
            % Phase index shift
            sii = k-3;
            % Phase index
            phaseInd = ii+sii;
            % Boundary check
            if phaseInd<1
                phaseInd = 1;
            end
            if phaseInd>numPhaseBins
                phaseInd = numPhaseBins;
            end
            
            for l = 1:5
                % Position index shift
                sjj = l-3;
                % Position index
                posInd = jj+sjj;
                % Boundary check
                if posInd<1
                    posInd = 1;
                end
                if posInd>numPosBins
                    posInd = numPosBins;
                end
                % Add to the smoothed rate for this bin
                sMap(ii,jj) = sMap(ii,jj) + map(phaseInd,posInd) * box(k,l);
            end
        end
    end
end
end

%%
function box = boxcarTemplate2D()

% Gaussian boxcar template
box = [0.0025 0.0125 0.0200 0.0125 0.0025;...
       0.0125 0.0625 0.1000 0.0625 0.0125;...
       0.0200 0.1000 0.1600 0.1000 0.0200;...
       0.0125 0.0625 0.1000 0.0625 0.0125;...
       0.0025 0.0125 0.0200 0.0125 0.0025;];
end